class FCurve():
    def __init__(self,data_path,array_index,keys):
        self.data_path = data_path
        self.array_index = array_index
        self.keys = keys

    def __repr__(self):
        return "F-Curve: %s[%s]"%(self.data_path,self.array_index)

class Keyframe():
    def __init__(self,co=[],handle_left=[],
        handle_right=[],interpolation="CONSTANT",
        amplitude=0.0,back=0.0,easing="AUTO",
        period=0.0,type="KEYFRAME",handle_left_type="FREE",
        handle_right_type="FREE"):
        self.co = co
        self.handle_left = handle_left
        self.handle_right = handle_right
        self.interpolation = interpolation
        self.amplitude = amplitude
        self.back = back
        self.easing = easing
        self.period = period
        self.type = type
        self.handle_left_type = handle_left_type
        self.handle_right_type = handle_right_type

    def __repr__(self):
        return "Keyframe co: (%s,%s), handle_left: (%s,%s), handle_right: (%s,%s)"%(self.co[0],self.co[1],
            self.handle_left[0],self.handle_left[1],self.handle_right[0],self.handle_right[1])